/usr/share/openvswitch/scripts/ovs-ctl is in openvswitch-switch 2.5.0-0ubuntu1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 | #! /bin/sh
# Copyright (C) 2009, 2010, 2011, 2012, 2013, 2014 Nicira, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
case $0 in
*/*) dir0=`echo "$0" | sed 's,/[^/]*$,,'` ;;
*) dir0=./ ;;
esac
. "$dir0/ovs-lib" || exit 1
for dir in "$sbindir" "$bindir" /sbin /bin /usr/sbin /usr/bin; do
case :$PATH: in
*:$dir:*) ;;
*) PATH=$PATH:$dir ;;
esac
done
## ----- ##
## start ##
## ----- ##
# Keep track of removed vports so we can reload them if needed
removed_vports=""
insert_mods () {
# Try loading openvswitch again.
action "Inserting openvswitch module" modprobe openvswitch
for vport in $removed_vports; do
# Don't treat failures to load vports as fatal error
action "Inserting $vport module" modprobe $vport || true
done
}
insert_mod_if_required () {
# If this kernel has no module support, expect we're done.
if test ! -e /proc/modules
then
log_success_msg "Kernel has no loadable module support. Skipping modprobe"
return 0
fi
# If openvswitch is already loaded then we're done.
test -e /sys/module/openvswitch -o -e /sys/module/openvswitch_mod && \
return 0
# Load openvswitch. If that's successful then we're done.
insert_mods && return 0
# If the bridge module is loaded, then that might be blocking
# openvswitch. Try to unload it, if there are no bridges.
test -e /sys/module/bridge || return 1
bridges=`echo /sys/class/net/*/bridge | sed 's,/sys/class/net/,,g;s,/bridge,,g'`
if test "$bridges" != "*"; then
log_warning_msg "not removing bridge module because bridges exist ($bridges)"
return 1
fi
action "removing bridge module" rmmod bridge || return 1
# Try loading openvswitch again.
insert_mods
}
ovs_vsctl () {
ovs-vsctl --no-wait "$@"
}
set_system_ids () {
set ovs_vsctl set Open_vSwitch .
OVS_VERSION=`ovs-vswitchd --version | sed 's/.*) //;1q'`
set "$@" ovs-version="$OVS_VERSION"
case $SYSTEM_ID in
random)
id_file=$etcdir/system-id.conf
uuid_file=$etcdir/install_uuid.conf
if test -e "$id_file"; then
SYSTEM_ID=`cat "$id_file"`
elif test -e "$uuid_file"; then
# Migrate from old file name.
. "$uuid_file"
SYSTEM_ID=$INSTALLATION_UUID
echo "$SYSTEM_ID" > "$id_file"
elif SYSTEM_ID=`uuidgen`; then
echo "$SYSTEM_ID" > "$id_file"
else
log_failure_msg "missing uuidgen, could not generate system ID"
fi
;;
'')
log_failure_msg "system ID not configured, please use --system-id"
;;
*)
;;
esac
set "$@" external-ids:system-id="\"$SYSTEM_ID\""
if test X"$SYSTEM_TYPE" != X; then
set "$@" system-type="\"$SYSTEM_TYPE\""
else
log_failure_msg "no default system type, please use --system-type"
fi
if test X"$SYSTEM_VERSION" != X; then
set "$@" system-version="\"$SYSTEM_VERSION\""
else
log_failure_msg "no default system version, please use --system-version"
fi
action "Configuring Open vSwitch system IDs" "$@" $extra_ids
}
check_force_cores () {
if test X"$FORCE_COREFILES" = Xyes; then
ulimit -c 67108864
fi
}
del_transient_ports () {
for port in `ovs-vsctl --bare -- --columns=name find port other_config:transient=true`; do
ovs_vsctl -- del-port "$port"
done
}
start_ovsdb () {
check_force_cores
if daemon_is_running ovsdb-server; then
log_success_msg "ovsdb-server is already running"
else
# Create initial database or upgrade database schema.
upgrade_db $DB_FILE $DB_SCHEMA || return 1
# Start ovsdb-server.
set ovsdb-server "$DB_FILE"
for db in $EXTRA_DBS; do
case $db in
/*) ;;
*) db=$dbdir/$db ;;
esac
if test ! -f "$db"; then
log_warning_msg "$db (from \$EXTRA_DBS) does not exist."
elif ovsdb-tool db-version "$db" >/dev/null; then
set "$@" "$db"
else
log_warning_msg "$db (from \$EXTRA_DBS) cannot be read as a database (see error message above)"
fi
done
set "$@" -vconsole:emer -vsyslog:err -vfile:info
set "$@" --remote=punix:"$DB_SOCK"
set "$@" --private-key=db:Open_vSwitch,SSL,private_key
set "$@" --certificate=db:Open_vSwitch,SSL,certificate
set "$@" --bootstrap-ca-cert=db:Open_vSwitch,SSL,ca_cert
start_daemon "$OVSDB_SERVER_PRIORITY" "$OVSDB_SERVER_WRAPPER" "$@" \
|| return 1
# Initialize database settings.
ovs_vsctl -- init -- set Open_vSwitch . db-version="$schemaver" \
|| return 1
set_system_ids || return 1
if test X"$DELETE_BRIDGES" = Xyes; then
for bridge in `ovs_vsctl list-br`; do
ovs_vsctl del-br $bridge
done
fi
if test X"$DELETE_TRANSIENT_PORTS" = Xyes; then
del_transient_ports
fi
fi
}
add_managers () {
# Now that ovs-vswitchd has started and completed its initial
# configuration, tell ovsdb-server to conenct to the remote managers. We
# used to do this at ovsdb-server startup time, but waiting for
# ovs-vswitchd to finish configuring means that remote managers see less
# churn in the database at startup or restart. (For example, managers
# won't briefly see empty datapath-id or ofport columns for records that
# exist at startup.)
action "Enabling remote OVSDB managers" \
ovs-appctl -t ovsdb-server ovsdb-server/add-remote \
db:Open_vSwitch,Open_vSwitch,manager_options
}
start_forwarding () {
check_force_cores
insert_mod_if_required || return 1
if daemon_is_running ovs-vswitchd; then
log_success_msg "ovs-vswitchd is already running"
else
# Increase the limit on the number of open file descriptors.
# On Linux, ovs-vswitchd needs about three file descriptors
# per bridge and "n-handler-threads" file descriptors per bridge
# port, so this allows a very large number of bridges and ports.
MAXFD=65535
if [ $(ulimit -n) -lt $MAXFD ]; then
ulimit -n $MAXFD
fi
# Start ovs-vswitchd.
set ovs-vswitchd
if test X"$DPDK_OPTS" != X; then
set "$@" $DPDK_OPTS --
fi
set "$@" unix:"$DB_SOCK"
set "$@" -vconsole:emer -vsyslog:err -vfile:info
if test X"$MLOCKALL" != Xno; then
set "$@" --mlockall
fi
start_daemon "$OVS_VSWITCHD_PRIORITY" "$OVS_VSWITCHD_WRAPPER" "$@"
fi
}
## ---- ##
## stop ##
## ---- ##
stop_ovsdb () {
stop_daemon ovsdb-server
}
stop_forwarding () {
stop_daemon ovs-vswitchd
}
## ----------------- ##
## force-reload-kmod ##
## ----------------- ##
internal_interfaces () {
# Outputs a list of internal interfaces:
#
# - There is an internal interface for every bridge, whether it
# has an Interface record or not and whether the Interface
# record's 'type' is properly set or not.
#
# - There is an internal interface for each Interface record whose
# 'type' is 'internal'.
#
# But ignore interfaces that don't really exist.
for d in `(ovs_vsctl --bare \
-- --columns=name find Interface type=internal \
-- list-br) | sort -u`
do
if test -e "/sys/class/net/$d"; then
printf "%s " "$d"
fi
done
}
ovs_save () {
bridges=`ovs_vsctl -- --real list-br`
if [ -n "${bridges}" ] && \
"$datadir/scripts/ovs-save" "$1" ${bridges} > "$2"; then
chmod +x "$2"
return 0
fi
[ -z "${bridges}" ] && return 0
}
save_ofports_if_required () {
# Save OpenFlow port numbers if we are upgrading from a pre-1.10 branch.
#
# (Versions 1.10 and later save OpenFlow port numbers without assistance,
# so we don't have to do anything for them.
case `ovs-appctl version | sed 1q` in
"ovs-vswitchd (Open vSwitch) 1."[0-9].*)
action "Saving ofport values" ovs_save save-ofports \
"${script_ofports}"
;;
esac
}
save_flows_if_required () {
if test X"$DELETE_BRIDGES" != Xyes; then
action "Saving flows" ovs_save save-flows "${script_flows}"
fi
}
save_interfaces () {
"$datadir/scripts/ovs-save" save-interfaces ${ifaces} \
> "${script_interfaces}"
}
restore_ofports () {
[ -x "${script_ofports}" ] && \
action "Restoring ofport values" "${script_ofports}"
}
flow_restore_wait () {
ovs_vsctl set open_vswitch . other_config:flow-restore-wait="true"
}
flow_restore_complete () {
ovs_vsctl --if-exists remove open_vswitch . other_config \
flow-restore-wait="true"
}
restore_flows () {
[ -x "${script_flows}" ] && \
action "Restoring saved flows" "${script_flows}"
}
restore_interfaces () {
[ ! -x "${script_interfaces}" ] && return 0
action "Restoring interface configuration" "${script_interfaces}"
rc=$?
if test $rc = 0; then
level=debug
else
level=err
fi
log="logger -p daemon.$level -t ovs-save"
$log "interface restore script exited with status $rc:"
$log -f "$script_interfaces"
}
init_restore_scripts () {
script_interfaces=`mktemp`
script_flows=`mktemp`
script_ofports=`mktemp`
trap 'rm -f "${script_interfaces}" "${script_flows}" "${script_ofports}"' 0
}
force_reload_kmod () {
ifaces=`internal_interfaces`
action "Detected internal interfaces: $ifaces" true
init_restore_scripts
save_flows_if_required
save_ofports_if_required
# Restart the database first, since a large database may take a
# while to load, and we want to minimize forwarding disruption.
stop_ovsdb
start_ovsdb
# Restore of ofports should happen before vswitchd is restarted.
restore_ofports
stop_forwarding
if action "Saving interface configuration" save_interfaces; then
:
else
log_warning_msg "Failed to save configuration, not replacing kernel module"
start_forwarding
add_managers
exit 1
fi
chmod +x "$script_interfaces"
for dp in `ovs-dpctl dump-dps`; do
action "Removing datapath: $dp" ovs-dpctl del-dp "$dp"
done
for vport in `awk '/^vport_/ { print $1 }' /proc/modules`; do
action "Removing $vport module" rmmod $vport
if ! grep -q $vport /proc/modules; then
removed_vports="$removed_vports $vport"
fi
done
# try both old and new names in case this is post upgrade
if test -e /sys/module/openvswitch_mod; then
action "Removing openvswitch module" rmmod openvswitch_mod
elif test -e /sys/module/openvswitch; then
action "Removing openvswitch module" rmmod openvswitch
fi
# Start vswitchd by asking it to wait till flow restore is finished.
flow_restore_wait
start_forwarding
# Restore saved flows and inform vswitchd that we are done.
restore_flows
flow_restore_complete
add_managers
restore_interfaces
"$datadir/scripts/ovs-check-dead-ifs"
}
## ------- ##
## restart ##
## ------- ##
save_interfaces_if_required () {
# Save interfaces if we are upgrading from a pre-1.10 branch.
case `ovs-appctl version | sed 1q` in
"ovs-vswitchd (Open vSwitch) 1."[0-9].*)
ifaces=`internal_interfaces`
action "Detected internal interfaces: $ifaces" true
if action "Saving interface configuration" save_interfaces; then
chmod +x "$script_interfaces"
fi
;;
esac
}
restart () {
if daemon_is_running ovsdb-server && daemon_is_running ovs-vswitchd; then
init_restore_scripts
save_interfaces_if_required
save_flows_if_required
save_ofports_if_required
fi
# Restart the database first, since a large database may take a
# while to load, and we want to minimize forwarding disruption.
stop_ovsdb
start_ovsdb
# Restore of ofports, if required, should happen before vswitchd is
# restarted.
restore_ofports
stop_forwarding
# Start vswitchd by asking it to wait till flow restore is finished.
flow_restore_wait
start_forwarding
# Restore saved flows and inform vswitchd that we are done.
restore_flows
flow_restore_complete
add_managers
# Restore the interfaces if required. Return true even if restore fails.
restore_interfaces || true
}
## --------------- ##
## enable-protocol ##
## --------------- ##
enable_protocol () {
# Translate the protocol name to a number, because "iptables -n -L" prints
# some protocols by name (despite the -n) and therefore we need to look for
# both forms.
#
# (iptables -S output is more uniform but old iptables doesn't have it.)
protonum=`grep "^$PROTOCOL[ ]" /etc/protocols | awk '{print $2}'`
if expr X"$protonum" : X'[0-9]\{1,\}$' > /dev/null; then :; else
log_failure_msg "unknown protocol $PROTOCOL"
return 1
fi
name=$PROTOCOL
match="(\$2 == \"$PROTOCOL\" || \$2 == $protonum)"
insert="iptables -I INPUT -p $PROTOCOL"
if test X"$DPORT" != X; then
name="$name to port $DPORT"
match="$match && /dpt:$DPORT/"
insert="$insert --dport $DPORT"
fi
if test X"$SPORT" != X; then
name="$name from port $SPORT"
match="$match && /spt:$SPORT/"
insert="$insert --sport $SPORT"
fi
insert="$insert -j ACCEPT"
if (iptables -n -L INPUT) >/dev/null 2>&1; then
if iptables -n -L INPUT | awk "$match { n++ } END { exit n == 0 }"
then
# There's already a rule for this protocol. Don't override it.
log_success_msg "iptables already has a rule for $name, not explicitly enabling"
else
action "Enabling $name with iptables" $insert
fi
elif (iptables --version) >/dev/null 2>&1; then
action "cannot list iptables rules, not adding a rule for $name"
else
action "iptables binary not installed, not adding a rule for $name"
fi
}
## ---- ##
## main ##
## ---- ##
set_defaults () {
SYSTEM_ID=
DELETE_BRIDGES=no
DELETE_TRANSIENT_PORTS=no
DAEMON_CWD=/
FORCE_COREFILES=yes
MLOCKALL=yes
OVSDB_SERVER_PRIORITY=-10
OVS_VSWITCHD_PRIORITY=-10
OVSDB_SERVER_WRAPPER=
OVS_VSWITCHD_WRAPPER=
DB_FILE=$dbdir/conf.db
DB_SOCK=$rundir/db.sock
DB_SCHEMA=$datadir/vswitch.ovsschema
EXTRA_DBS=
PROTOCOL=gre
DPORT=
SPORT=
type_file=$etcdir/system-type.conf
version_file=$etcdir/system-version.conf
if test -e "$type_file" ; then
SYSTEM_TYPE=`cat $type_file`
SYSTEM_VERSION=`cat $version_file`
elif (lsb_release --id) >/dev/null 2>&1; then
SYSTEM_TYPE=`lsb_release --id -s`
system_release=`lsb_release --release -s`
system_codename=`lsb_release --codename -s`
SYSTEM_VERSION="${system_release}-${system_codename}"
else
SYSTEM_TYPE=unknown
SYSTEM_VERSION=unknown
fi
}
usage () {
set_defaults
cat <<EOF
$0: controls Open vSwitch daemons
usage: $0 [OPTIONS] COMMAND
This program is intended to be invoked internally by Open vSwitch startup
scripts. System administrators should not normally invoke it directly.
Commands:
start start Open vSwitch daemons
stop stop Open vSwitch daemons
restart stop and start Open vSwitch daemons
status check whether Open vSwitch daemons are running
version print versions of Open vSwitch daemons
load-kmod insert modules if not already present
force-reload-kmod save OVS network device state, stop OVS, unload kernel
module, reload kernel module, start OVS, restore state
enable-protocol enable protocol specified in options with iptables
help display this help message
One of the following options is required for "start", "restart" and "force-reload-kmod":
--system-id=UUID set specific ID to uniquely identify this system
--system-id=random use a random but persistent UUID to identify this system
Other important options for "start", "restart" and "force-reload-kmod":
--system-type=TYPE set system type (e.g. "XenServer")
--system-version=VERSION set system version (e.g. "5.6.100-39265p")
--external-id="key=value"
add given key-value pair to Open_vSwitch external-ids
--delete-bridges delete all bridges just before starting ovs-vswitchd
Less important options for "start", "restart" and "force-reload-kmod":
--daemon-cwd=DIR set working dir for OVS daemons (default: $DAEMON_CWD)
--no-force-corefiles do not force on core dumps for OVS daemons
--no-mlockall do not lock all of ovs-vswitchd into memory
--ovsdb-server-priority=NICE set ovsdb-server's niceness (default: $OVSDB_SERVER_PRIORITY)
--ovs-vswitchd-priority=NICE set ovs-vswitchd's niceness (default: $OVS_VSWITCHD_PRIORITY)
Debugging options for "start", "restart" and "force-reload-kmod":
--ovsdb-server-wrapper=WRAPPER
--ovs-vswitchd-wrapper=WRAPPER
--ovs-vswitchd-wrapper=WRAPPER
run specified daemon under WRAPPER (either 'valgrind' or 'strace')
File location options:
--db-file=FILE database file name (default: $DB_FILE)
--db-sock=SOCKET JSON-RPC socket name (default: $DB_SOCK)
--db-schema=FILE database schema file name (default: $DB_SCHEMA)
Options for "enable-protocol":
--protocol=PROTOCOL protocol to enable with iptables (default: gre)
--sport=PORT source port to match (for tcp or udp protocol)
--dport=PORT ddestination port to match (for tcp or udp protocol)
Other options:
-h, --help display this help message
-V, --version display version information
Default directories with "configure" option and environment variable override:
logs: /var/log/openvswitch (--with-logdir, OVS_LOGDIR)
pidfiles and sockets: /var/run/openvswitch (--with-rundir, OVS_RUNDIR)
conf.db: /etc/openvswitch (--with-dbdir, OVS_DBDIR)
system configuration: /etc (--sysconfdir, OVS_SYSCONFDIR)
data files: /usr/share/openvswitch (--pkgdatadir, OVS_PKGDATADIR)
user binaries: /usr/bin (--bindir, OVS_BINDIR)
system binaries: /usr/sbin (--sbindir, OVS_SBINDIR)
Please report bugs to bugs@openvswitch.org (see REPORTING-BUGS for details).
EOF
exit 0
}
set_option () {
var=`echo "$option" | tr abcdefghijklmnopqrstuvwxyz- ABCDEFGHIJKLMNOPQRSTUVWXYZ_`
eval set=\${$var+yes}
eval old_value=\$$var
if test X$set = X || \
(test $type = bool && \
test X"$old_value" != Xno && test X"$old_value" != Xyes); then
echo >&2 "$0: unknown option \"$arg\" (use --help for help)"
return
fi
eval $var=\$value
}
daemons () {
echo ovsdb-server ovs-vswitchd
}
set_defaults
extra_ids=
command=
for arg
do
case $arg in
-h | --help)
usage
;;
-V | --version)
echo "$0 (Open vSwitch) $VERSION"
exit 0
;;
--external-id=*)
value=`expr X"$arg" : 'X[^=]*=\(.*\)'`
case $value in
*=*)
extra_ids="$extra_ids external-ids:$value"
;;
*)
echo >&2 "$0: --external-id argument not in the form \"key=value\""
exit 1
;;
esac
;;
--[a-z]*=*)
option=`expr X"$arg" : 'X--\([^=]*\)'`
value=`expr X"$arg" : 'X[^=]*=\(.*\)'`
type=string
set_option
;;
--no-[a-z]*)
option=`expr X"$arg" : 'X--no-\(.*\)'`
value=no
type=bool
set_option
;;
--[a-z]*)
option=`expr X"$arg" : 'X--\(.*\)'`
value=yes
type=bool
set_option
;;
-*)
echo >&2 "$0: unknown option \"$arg\" (use --help for help)"
exit 1
;;
*)
if test X"$command" = X; then
command=$arg
else
echo >&2 "$0: exactly one non-option argument required (use --help for help)"
exit 1
fi
;;
esac
done
case $command in
start)
start_ovsdb || exit 1
start_forwarding
add_managers
;;
stop)
stop_forwarding
stop_ovsdb
;;
restart)
restart
;;
status)
rc=0
for daemon in `daemons`; do
daemon_status $daemon || rc=$?
done
exit $rc
;;
version)
for daemon in `daemons`; do
$daemon --version
done
;;
force-reload-kmod)
force_reload_kmod
;;
load-kmod)
insert_mod_if_required
;;
enable-protocol)
enable_protocol
;;
help)
usage
;;
'')
echo >&2 "$0: missing command name (use --help for help)"
exit 1
;;
*)
echo >&2 "$0: unknown command \"$command\" (use --help for help)"
exit 1
;;
esac
|